/*****************************************************************
|
|      Xaudio Player for Windows CE  
|      Utility Functions    
|
|      (c) 1996-1998 MpegTV, LLC
|      Author: Gilles Boccon-Gibod (gilles@mpegtv.com)
|
 ****************************************************************/

#ifndef __CEUTILS_H__
#define __CEUTILS_H__

/*----------------------------------------------------------------------
|       includes
+---------------------------------------------------------------------*/

#ifdef WIN32
#include <windows.h>
#include <tchar.h>
#endif

#ifdef UNDER_CE
#include <malloc.h>

/*----------------------------------------------------------------------
|       functions and macros
+---------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

extern LPWSTR A2WConvert(LPWSTR lpw, LPCSTR lpa, int nChars);
extern LPSTR W2AConvert(LPSTR lpa, LPCWSTR lpw, int nChars);

#define USES_CONVERSION int _convert
#define A2W(lpa) (\
	((LPCSTR)lpa == NULL) ? NULL : (\
		_convert = (strlen(lpa)+1),\
		A2WConvert((LPWSTR) _alloca(_convert*2), lpa, _convert)))

#define W2A(lpw) (\
	((LPCWSTR)lpw == NULL) ? NULL : (\
		_convert = (wcslen(lpw)+1)*2,\
		W2AConvert((LPSTR) _alloca(_convert), lpw, _convert)))

#ifdef __cplusplus
}
#endif

#else /* not UNDER_CE */

#ifndef WIN32
typedef char TCHAR;
#define TEXT(s) s
#endif
#define USES_CONVERSION
#define A2W(lpa) lpa
#define W2A(lpw) lpw
#define swprintf	sprintf

#endif /* not UNDER_CE */

#endif /* __CEUTILS_H__ */
