/* Copyright (c) 1997, MpegTV LLC */
#ifndef _g2a_api_h
#define _g2a_api_h
#ifndef lint
static const char rcsid_g2a_api_h[] = "$Header: /net/hopkins/home/tristan/mpeg/dec/RCS/g2a_api.h,v 1.1 1999/08/03 08:05:19 tristan Exp tristan $";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

#include "misc.h"
#include "com_api.h"
#include "state_api.h"


/*--------------------------------------------------------------------------+
| Data types
+--------------------------------------------------------------------------*/
/* param for msg from control to player (union) */
typedef union {
	MTVP_PMP_DATA_GENERIC	data_generic;
	char	data_reserved[1024]; 
} MTVP_PMP_DATA_G2A;

typedef struct mtvp_player MTVP_PLAYER;

/*--------------------------------------------------------------------------+
| External
+--------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif

extern int mtvp_send_command(MTVP_PLAYER *player, MTVP_PMP_HEADER *, const MTVP_PMP_DATA_G2A *);
extern int mtvp_send_command_double(MTVP_PLAYER *player, MTVP_COMMAND, int flags, double data_double);
extern int mtvp_send_command_int(MTVP_PLAYER *player, MTVP_COMMAND, int flags, int data_int);
extern int mtvp_send_command_string(MTVP_PLAYER *player, MTVP_COMMAND, int flags, const char *data_string);
extern int mtvp_send_command_custom(MTVP_PLAYER *player, MTVP_COMMAND, int flags, const void *data_custom, u_int data_size);
extern int mtvp_send_command_void(MTVP_PLAYER *player, MTVP_COMMAND, int flags);
extern int mtvp_create_player(MTVP_PLAYER **result_player_ptr, const char **mtvp_argv, const char *argv0, void *platform_ptr);
extern int mtvp_destroy_player(MTVP_PLAYER *player);
extern int mtvp_read_notification(const MTVP_PLAYER *player, MTVP_PMP_HEADER *result_header, MTVP_PMP_DATA_A2G *result_data);
extern Bool mtvp_check_notification(const MTVP_PLAYER *player);
#ifdef WIN32
extern int mtvp_translate_msg(const MTVP_PLAYER *player, UINT message, WPARAM wParam, LPARAM lParam, MTVP_PMP_HEADER *result_header, MTVP_PMP_DATA_A2G *result_data);
#else
extern int mtvp_get_notification_fd(const MTVP_PLAYER *player);
#endif
extern int mtvp_get_command_status(MTVP_PLAYER *player, int *status_ptr, void **returned_value);

#ifdef __cplusplus
}
#endif


#endif /* _g2a_api_h */
